package org.gcube.portlets.user.workspace.client.view;

import org.gcube.portlets.user.workspace.client.view.grids.GxtGridFilterGroupPanel;
import org.gcube.portlets.user.workspace.client.view.panels.GxtBasicTabPanel;
import org.gcube.portlets.user.workspace.client.view.panels.GxtBorderLayoutPanel;
import org.gcube.portlets.user.workspace.client.view.panels.GxtCardLayoutResultPanel;
import org.gcube.portlets.user.workspace.client.view.panels.GxtSeachAndFilterPanel;
import org.gcube.portlets.user.workspace.client.view.toolbars.GxtPathPanel;
import org.gcube.portlets.user.workspace.client.view.toolbars.GxtToolBarItemAccounting;


/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
public class WorskpacePortlet {

	private GxtBorderLayoutPanel borderLayoutContainer = null;
	private GxtBasicTabPanel basicTabContainer = null;
//	private GxtToolBarFunctionsPanel toolbarPanelContainer = null;
	private ExplorerPanel explorerPanel = null;
	private GxtToolBarItemAccounting toolBarItemDetails;
	private GxtListView listViewContainer;
	private GxtPathPanel toolBarPathPanel;
	private GxtGridFilterGroupPanel gridFilterGroupContainer;
	private GxtSeachAndFilterPanel searchAndFilterContainer;
	private GxtCardLayoutResultPanel gxtCardLayoutResultPanel; 

	public WorskpacePortlet(boolean activeGroup) {

//		Log.trace("Initializing WorskpacePortlet");
		this.basicTabContainer = new GxtBasicTabPanel();
		this.toolBarPathPanel = new GxtPathPanel();
		this.searchAndFilterContainer = new GxtSeachAndFilterPanel(this.toolBarPathPanel.getToolBarPathPanel());
			
		this.gridFilterGroupContainer = new GxtGridFilterGroupPanel(activeGroup);
		this.listViewContainer = new GxtListView();
		this.toolBarItemDetails = new GxtToolBarItemAccounting();

		
		this.gxtCardLayoutResultPanel = new GxtCardLayoutResultPanel(gridFilterGroupContainer, listViewContainer, toolBarItemDetails);
		
	}
	
	public WorskpacePortlet(ExplorerPanel expPanel, boolean activeGroup) {
		this(activeGroup);
		this.explorerPanel = expPanel;
		
		this.borderLayoutContainer = new GxtBorderLayoutPanel(this.searchAndFilterContainer, this.explorerPanel, this.gxtCardLayoutResultPanel, this.toolBarItemDetails);
	}

	public GxtBorderLayoutPanel getBorderLayoutContainer() {
		return borderLayoutContainer;
	}
	
	public GxtBasicTabPanel getBasicTabContainer() {
		return basicTabContainer;
	}
	
	public GxtToolBarItemAccounting getDetailsContainer() {
		return toolBarItemDetails;
	}


	public GxtSeachAndFilterPanel getSearchAndFilterContainer() {
		return searchAndFilterContainer;
	}


	public GxtPathPanel getToolBarPath() {
		return toolBarPathPanel;
	}


	public GxtGridFilterGroupPanel getGridGroupContainer() {
		return gridFilterGroupContainer;
	}


	public ExplorerPanel getExplorerPanel() {
		return explorerPanel;
	}
	
	public GxtCardLayoutResultPanel getGxtCardLayoutResultPanel() {
		return gxtCardLayoutResultPanel;
	}

	public GxtToolBarItemAccounting getToolBarItemDetails() {
		return toolBarItemDetails;
	}
}
